searchNodes=[{"ref":"Maestro.Aggregate.CommandHandler.html","title":"Maestro.Aggregate.CommandHandler","type":"behaviour","doc":"Simple behaviour for properly implementing command handlers the way that maestro expects. Its use is not required but is encouraged."},{"ref":"Maestro.Aggregate.CommandHandler.html#c:eval/2","title":"Maestro.Aggregate.CommandHandler.eval/2","type":"callback","doc":"Command handlers in maestro should implement an eval function that expects to receive the current Root object complete with sequence number and aggregate ID and the incoming command. They should return a list of events or raise an error which can be used to short circuit the command processing cycle."},{"ref":"Maestro.Aggregate.CommandHandler.html#t:command/0","title":"Maestro.Aggregate.CommandHandler.command/0","type":"type","doc":""},{"ref":"Maestro.Aggregate.CommandHandler.html#t:event/0","title":"Maestro.Aggregate.CommandHandler.event/0","type":"type","doc":""},{"ref":"Maestro.Aggregate.CommandHandler.html#t:root/0","title":"Maestro.Aggregate.CommandHandler.root/0","type":"type","doc":""},{"ref":"Maestro.Aggregate.EventHandler.html","title":"Maestro.Aggregate.EventHandler","type":"behaviour","doc":"Minimal behaviour for a proper event handler. Like the CommandHandler, the use of the behaviour is not strictly required."},{"ref":"Maestro.Aggregate.EventHandler.html#c:apply/2","title":"Maestro.Aggregate.EventHandler.apply/2","type":"callback","doc":"Event handlers must succeed in their application of the event. Validation and other forms of rejection/failure should be done in the command handler. This is made evident in the spec for apply in that the result should always be a new valid state."},{"ref":"Maestro.Aggregate.EventHandler.html#t:event/0","title":"Maestro.Aggregate.EventHandler.event/0","type":"type","doc":""},{"ref":"Maestro.Aggregate.ProjectionHandler.html","title":"Maestro.Aggregate.ProjectionHandler","type":"behaviour","doc":"ProjectionHandlers are used to manage alternate representations of an aggregate. This defines a minimal behaviour for use within the aggregate command/event lifecycle. For projections that should be updated immediately iff the relevant events are committed, the relevant ProjectionHandler should by included in the list of :projections on the aggregate root."},{"ref":"Maestro.Aggregate.ProjectionHandler.html#c:project/1","title":"Maestro.Aggregate.ProjectionHandler.project/1","type":"callback","doc":"Projections registered with an aggregate root are invoked for every event, so they should ignore unrelated events explicitly."},{"ref":"Maestro.Aggregate.ProjectionHandler.html#t:event/0","title":"Maestro.Aggregate.ProjectionHandler.event/0","type":"type","doc":""},{"ref":"Maestro.Aggregate.Root.html","title":"Maestro.Aggregate.Root","type":"behaviour","doc":"Core behaviour and functionality provided by Maestro for processing commands and managing aggregate state. Traditional domain entities are referred to as aggregates in the literature. At the outermost edge of a bounded context, you find an aggregate root. The goal of this library is to greatly simplify the process of implementing an event sourced application by owning the flow of non-domain data (i.e. commands, events, and snapshots) to allow you to focus on the business logic of evaluating your commands and applying the subsequent events to your domain objects. The most crucial piece to this is the aggregate root. Maestro.Aggregate.CommandHandler defines a behaviour with the goal of isolating a single command handler&#39;s eval. Similarly, there is the Maestro.Aggregate.EventHandler behaviour which defines how to apply that event to the aggregate. With these key components modeled explicitly, the Maestro.Aggregate.Root focuses on the dataflow and ensuring that queries to aggregate state flow properly. The aggregate root dispatches to the particular command handlers and event handlers by means of an opinionated dynamic dispatch. To ensure that these things are handled in a consistent manner, the aggregate root is modeled as a GenServer and provides the requisite lifecycle hooks. use Maestro.Aggregate.Root takes the following options: :command_prefix - module prefix for finding commands :event_prefix - module prefix for finding events :projections - zero or more modules that implement the ProjectionHandler behaviour for the events that are generated by this aggregate root. These projections are invoked within the transaction that commits the events."},{"ref":"Maestro.Aggregate.Root.html#c:call/2","title":"Maestro.Aggregate.Root.call/2","type":"callback","doc":"If you extend the aggregate to provide other functionality, call is available to assist in pushing that functionality into the aggregate&#39;s context."},{"ref":"Maestro.Aggregate.Root.html#child_spec/1","title":"Maestro.Aggregate.Root.child_spec/1","type":"function","doc":""},{"ref":"Maestro.Aggregate.Root.html#c:evaluate/1","title":"Maestro.Aggregate.Root.evaluate/1","type":"callback","doc":"Evaluate the command within the aggregate&#39;s context."},{"ref":"Maestro.Aggregate.Root.html#event_type/2","title":"Maestro.Aggregate.Root.event_type/2","type":"function","doc":"struct to event type of the form &quot;The.ModuleName -&gt; the.module_name&quot; dropping the provided prefix for conciseness"},{"ref":"Maestro.Aggregate.Root.html#c:fetch/1","title":"Maestro.Aggregate.Root.fetch/1","type":"callback","doc":"Forces the aggregate to retrieve any events. Since Maestro operates in a node-local manner, it&#39;s entirely possible some other node has processed commands/events."},{"ref":"Maestro.Aggregate.Root.html#c:get/1","title":"Maestro.Aggregate.Root.get/1","type":"callback","doc":"A (potentially) stale read of the aggregate&#39;s state. If you want to ensure the state is as up-to-date as possible, see fetch/1."},{"ref":"Maestro.Aggregate.Root.html#c:initial_state/0","title":"Maestro.Aggregate.Root.initial_state/0","type":"callback","doc":"When an aggregate root is created, this callback is invoked to generate the state"},{"ref":"Maestro.Aggregate.Root.html#c:new/0","title":"Maestro.Aggregate.Root.new/0","type":"callback","doc":"Create a new aggregate along with the provided initial_state function. This function should only fail if there was a problem generating an HLC timestamp."},{"ref":"Maestro.Aggregate.Root.html#c:prepare_snapshot/1","title":"Maestro.Aggregate.Root.prepare_snapshot/1","type":"callback","doc":"Snapshots are stored in a single-row-per-aggregate manner and are used to make it easier/faster to hydrate the aggregate root. This function should return the map which will be JSON encoded when moving to a durable store."},{"ref":"Maestro.Aggregate.Root.html#c:replay/2","title":"Maestro.Aggregate.Root.replay/2","type":"callback","doc":"Recover a past version of the aggregate&#39;s state by specifying a maximum sequence number. The aggregate&#39;s snapshot and any/all events will be used to get the state back to that point."},{"ref":"Maestro.Aggregate.Root.html#c:snapshot/1","title":"Maestro.Aggregate.Root.snapshot/1","type":"callback","doc":"Using the aggregate root&#39;s prepare_snapshot function, generate and store a snapshot. Useful if there are a lot of events, big events, or just a healthy amount of aggregate state to compose."},{"ref":"Maestro.Aggregate.Root.html#start_link/1","title":"Maestro.Aggregate.Root.start_link/1","type":"function","doc":""},{"ref":"Maestro.Aggregate.Root.html#c:use_snapshot/2","title":"Maestro.Aggregate.Root.use_snapshot/2","type":"callback","doc":"Moving from the snapshotted representation to the aggregate root&#39;s structure can be a complicated process that requires custom hooks. Otherwise, a default implementation is provided that simply lifts the map out of the snapshot and uses it as the state of the aggregate."},{"ref":"Maestro.Aggregate.Root.html#whereis/2","title":"Maestro.Aggregate.Root.whereis/2","type":"function","doc":"Look up an aggregate by its ID. The module is provided to start the right type of aggregate should it not already be started."},{"ref":"Maestro.Aggregate.Root.html#t:command/0","title":"Maestro.Aggregate.Root.command/0","type":"type","doc":""},{"ref":"Maestro.Aggregate.Root.html#t:id/0","title":"Maestro.Aggregate.Root.id/0","type":"type","doc":""},{"ref":"Maestro.Aggregate.Root.html#t:sequence/0","title":"Maestro.Aggregate.Root.sequence/0","type":"type","doc":""},{"ref":"Maestro.Aggregate.Root.html#t:stack/0","title":"Maestro.Aggregate.Root.stack/0","type":"type","doc":""},{"ref":"Maestro.Aggregate.Root.html#t:t/0","title":"Maestro.Aggregate.Root.t/0","type":"type","doc":""},{"ref":"Maestro.Aggregate.Supervisor.html","title":"Maestro.Aggregate.Supervisor","type":"module","doc":"Supervisor for Maestro.Aggregate.Roots across any/all domains. All aggregate roots, no matter how many different kinds you may have, are managed by a single supervisor/registry (for now). Given that aggregates are independently configurable and extensible, the need for a 1:1 on supervisors per aggregate is a premature optimization. Furthermore, aggregate IDs are HLC timestamps and are thus unique even across aggregates."},{"ref":"Maestro.Aggregate.Supervisor.html#child_spec/1","title":"Maestro.Aggregate.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Maestro.Aggregate.Supervisor.html#get_child/2","title":"Maestro.Aggregate.Supervisor.get_child/2","type":"function","doc":""},{"ref":"Maestro.Aggregate.Supervisor.html#init/1","title":"Maestro.Aggregate.Supervisor.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke DynamicSupervisor.init/1 at the end of their init callback to return the proper supervision flags. Callback implementation for DynamicSupervisor.init/1."},{"ref":"Maestro.Aggregate.Supervisor.html#start_link/1","title":"Maestro.Aggregate.Supervisor.start_link/1","type":"function","doc":""},{"ref":"Maestro.InvalidCommandError.html","title":"Maestro.InvalidCommandError","type":"exception","doc":"The preferred exception for informing the client that their command was rejected for any reason."},{"ref":"Maestro.InvalidHandlerError.html","title":"Maestro.InvalidHandlerError","type":"exception","doc":"An exception that will be raised by Maestro.Aggregate.Root.lookup_module/2 if it fails to find the module implied by the prefix and type provided."},{"ref":"Maestro.InvalidHandlerError.html#message/1","title":"Maestro.InvalidHandlerError.message/1","type":"function","doc":"Callback implementation for Exception.message/1."},{"ref":"Maestro.Store.html","title":"Maestro.Store","type":"module","doc":"Concise API for events and snapshots. If you are using the Maestro.Store.Postgres adapter, an Ecto.Repo should be provided."},{"ref":"Maestro.Store.html#commit_all/2","title":"Maestro.Store.commit_all/2","type":"function","doc":"Commit the events and apply all projections within a transaction. If there&#39;s a sequence number conflict, the events and projections will be discarded such that the command generating these components could be retried."},{"ref":"Maestro.Store.html#commit_events/1","title":"Maestro.Store.commit_events/1","type":"function","doc":"Commit the events provided iff there is no sequence number conflict. Otherwise, the command should be retried as indicated by the specific error tuple."},{"ref":"Maestro.Store.html#commit_snapshot/1","title":"Maestro.Store.commit_snapshot/1","type":"function","doc":"Store the snapshot iff the sequence number is greater than what is in the store. This allows nodes that are partitioned from each other to treat the store as the source of truth even when writing snapshots."},{"ref":"Maestro.Store.html#get_events/3","title":"Maestro.Store.get_events/3","type":"function","doc":"Retrieve all events for a specific aggregate by id and minimum sequence number. Options include: :max_sequence - useful hydration purposes (defaults to max_sequence/0)"},{"ref":"Maestro.Store.html#get_snapshot/3","title":"Maestro.Store.get_snapshot/3","type":"function","doc":"Retrieve a snapshot by aggregate id and minimum sequence number. If no snapshot is found, nil is returned. Options include: :max_sequence - useful hydration purposes (defaults to max_sequence/0)"},{"ref":"Maestro.Store.html#max_sequence/0","title":"Maestro.Store.max_sequence/0","type":"function","doc":"Return the maximum allowable sequence number permitted by the durable storage adapter."},{"ref":"Maestro.Store.html#t:event/0","title":"Maestro.Store.event/0","type":"type","doc":""},{"ref":"Maestro.Store.html#t:events/0","title":"Maestro.Store.events/0","type":"type","doc":""},{"ref":"Maestro.Store.html#t:id/0","title":"Maestro.Store.id/0","type":"type","doc":""},{"ref":"Maestro.Store.html#t:opts/0","title":"Maestro.Store.opts/0","type":"type","doc":""},{"ref":"Maestro.Store.html#t:sequence/0","title":"Maestro.Store.sequence/0","type":"type","doc":""},{"ref":"Maestro.Store.html#t:snapshot/0","title":"Maestro.Store.snapshot/0","type":"type","doc":""},{"ref":"Maestro.Store.Adapter.html","title":"Maestro.Store.Adapter","type":"behaviour","doc":"Defines the minimal API for a well-behaved storage implementation."},{"ref":"Maestro.Store.Adapter.html#c:commit_all/2","title":"Maestro.Store.Adapter.commit_all/2","type":"callback","doc":"If any transactional projections are present, this function is an extension of commit_events that within the same transaction applies all projections to the store as well. Otherwise, this function dispatches to commit_events."},{"ref":"Maestro.Store.Adapter.html#c:commit_events/1","title":"Maestro.Store.Adapter.commit_events/1","type":"callback","doc":"Events are validated according to the Event.changeset/1 function. If successful, events are committed transactionally. In the event of a conflict on sequence number, the storage mechanism should indicate that the command could be retried by returning {:error, :retry_command}. The Aggregate&#39;s command lifecycle will see the conflict and update the aggregate&#39;s state before attempting to evaluate the command again. This allows for making stricter evaluation rules for commands. If the events could not be committed for any other reason, the storage mechanism should raise an appropriate exception."},{"ref":"Maestro.Store.Adapter.html#c:commit_snapshot/1","title":"Maestro.Store.Adapter.commit_snapshot/1","type":"callback","doc":"Snapshots are committed iff the proposed version is newer than the version already stored. This allows disconnected nodes to optimistically write their snapshots and still have a single version stored without conflicts."},{"ref":"Maestro.Store.Adapter.html#c:get_events/3","title":"Maestro.Store.Adapter.get_events/3","type":"callback","doc":"Events are retrieved by aggregate_id and with at least a minimum sequence number, seq. They should be ordered by sequence number to ensure that aggregates always process events in the same order. Additional option(s): :max_sequence (integer): a hard upper limit on the sequence number. This is useful when attempting to recreate a past state of an aggregate."},{"ref":"Maestro.Store.Adapter.html#c:get_snapshot/3","title":"Maestro.Store.Adapter.get_snapshot/3","type":"callback","doc":"Snapshots can also be retrieved by aggregate_id and with at least a minimum sequence number, seq. Additional option(s): :max_sequence (integer): a hard upper limit on the sequence number. This is useful when attempting to recreate a past state of an aggregate."},{"ref":"Maestro.Store.Adapter.html#t:id/0","title":"Maestro.Store.Adapter.id/0","type":"type","doc":""},{"ref":"Maestro.Store.Adapter.html#t:options/0","title":"Maestro.Store.Adapter.options/0","type":"type","doc":""},{"ref":"Maestro.Store.Adapter.html#t:seq/0","title":"Maestro.Store.Adapter.seq/0","type":"type","doc":""},{"ref":"Maestro.Store.InMemory.html","title":"Maestro.Store.InMemory","type":"module","doc":"Agent-based implementation of the event/snapshot storage mechanism"},{"ref":"Maestro.Store.InMemory.html#child_spec/1","title":"Maestro.Store.InMemory.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Maestro.Store.InMemory.html#commit_all/2","title":"Maestro.Store.InMemory.commit_all/2","type":"function","doc":"If any transactional projections are present, this function is an extension of commit_events that within the same transaction applies all projections to the store as well. Otherwise, this function dispatches to commit_events. Callback implementation for Maestro.Store.Adapter.commit_all/2."},{"ref":"Maestro.Store.InMemory.html#commit_events/1","title":"Maestro.Store.InMemory.commit_events/1","type":"function","doc":"Events are validated according to the Event.changeset/1 function. If successful, events are committed transactionally. In the event of a conflict on sequence number, the storage mechanism should indicate that the command could be retried by returning {:error, :retry_command}. The Aggregate&#39;s command lifecycle will see the conflict and update the aggregate&#39;s state before attempting to evaluate the command again. This allows for making stricter evaluation rules for commands. If the events could not be committed for any other reason, the storage mechanism should raise an appropriate exception. Callback implementation for Maestro.Store.Adapter.commit_events/1."},{"ref":"Maestro.Store.InMemory.html#commit_snapshot/1","title":"Maestro.Store.InMemory.commit_snapshot/1","type":"function","doc":"Snapshots are committed iff the proposed version is newer than the version already stored. This allows disconnected nodes to optimistically write their snapshots and still have a single version stored without conflicts. Callback implementation for Maestro.Store.Adapter.commit_snapshot/1."},{"ref":"Maestro.Store.InMemory.html#get_events/3","title":"Maestro.Store.InMemory.get_events/3","type":"function","doc":"Events are retrieved by aggregate_id and with at least a minimum sequence number, seq. They should be ordered by sequence number to ensure that aggregates always process events in the same order. Additional option(s): :max_sequence (integer): a hard upper limit on the sequence number. This is useful when attempting to recreate a past state of an aggregate. Callback implementation for Maestro.Store.Adapter.get_events/3."},{"ref":"Maestro.Store.InMemory.html#get_snapshot/3","title":"Maestro.Store.InMemory.get_snapshot/3","type":"function","doc":"Snapshots can also be retrieved by aggregate_id and with at least a minimum sequence number, seq. Additional option(s): :max_sequence (integer): a hard upper limit on the sequence number. This is useful when attempting to recreate a past state of an aggregate. Callback implementation for Maestro.Store.Adapter.get_snapshot/3."},{"ref":"Maestro.Store.InMemory.html#in_range?/3","title":"Maestro.Store.InMemory.in_range?/3","type":"function","doc":""},{"ref":"Maestro.Store.InMemory.html#reset/0","title":"Maestro.Store.InMemory.reset/0","type":"function","doc":""},{"ref":"Maestro.Store.InMemory.html#start_link/0","title":"Maestro.Store.InMemory.start_link/0","type":"function","doc":""},{"ref":"Maestro.Store.Postgres.html","title":"Maestro.Store.Postgres","type":"module","doc":"Ecto+Postgres implementation of the storage mechanism. Events are never replayed outside of the aggregate&#39;s context, so the implementation doesn&#39;t support retrieval without an aggregate ID."},{"ref":"Maestro.Store.Postgres.html#commit_all/2","title":"Maestro.Store.Postgres.commit_all/2","type":"function","doc":"If any transactional projections are present, this function is an extension of commit_events that within the same transaction applies all projections to the store as well. Otherwise, this function dispatches to commit_events. Callback implementation for Maestro.Store.Adapter.commit_all/2."},{"ref":"Maestro.Store.Postgres.html#commit_events/1","title":"Maestro.Store.Postgres.commit_events/1","type":"function","doc":"Events are validated according to the Event.changeset/1 function. If successful, events are committed transactionally. In the event of a conflict on sequence number, the storage mechanism should indicate that the command could be retried by returning {:error, :retry_command}. The Aggregate&#39;s command lifecycle will see the conflict and update the aggregate&#39;s state before attempting to evaluate the command again. This allows for making stricter evaluation rules for commands. If the events could not be committed for any other reason, the storage mechanism should raise an appropriate exception. Callback implementation for Maestro.Store.Adapter.commit_events/1."},{"ref":"Maestro.Store.Postgres.html#commit_snapshot/1","title":"Maestro.Store.Postgres.commit_snapshot/1","type":"function","doc":"Snapshots are committed iff the proposed version is newer than the version already stored. This allows disconnected nodes to optimistically write their snapshots and still have a single version stored without conflicts. Callback implementation for Maestro.Store.Adapter.commit_snapshot/1."},{"ref":"Maestro.Store.Postgres.html#get_events/3","title":"Maestro.Store.Postgres.get_events/3","type":"function","doc":"Events are retrieved by aggregate_id and with at least a minimum sequence number, seq. They should be ordered by sequence number to ensure that aggregates always process events in the same order. Additional option(s): :max_sequence (integer): a hard upper limit on the sequence number. This is useful when attempting to recreate a past state of an aggregate. Callback implementation for Maestro.Store.Adapter.get_events/3."},{"ref":"Maestro.Store.Postgres.html#get_snapshot/3","title":"Maestro.Store.Postgres.get_snapshot/3","type":"function","doc":"Snapshots can also be retrieved by aggregate_id and with at least a minimum sequence number, seq. Additional option(s): :max_sequence (integer): a hard upper limit on the sequence number. This is useful when attempting to recreate a past state of an aggregate. Callback implementation for Maestro.Store.Adapter.get_snapshot/3."},{"ref":"Maestro.Types.Command.html","title":"Maestro.Types.Command","type":"module","doc":"Commands are the primary way clients express a desire to change the system. In Maestro, commands are always executed within the context of an aggregate in a consistent manner."},{"ref":"Maestro.Types.Command.html#t:t/0","title":"Maestro.Types.Command.t/0","type":"type","doc":""},{"ref":"Maestro.Types.Event.html","title":"Maestro.Types.Event","type":"module","doc":"Events are the key component from which state changes are made and projections can be built. In order to ensure consistent application of events, they are always retrieved in order by sequence number. Additionally, events with conflicting sequence numbers will be rejected, and the aggregate can retry the command that generated the events that were committed second."},{"ref":"Maestro.Types.Event.html#changeset/1","title":"Maestro.Types.Event.changeset/1","type":"function","doc":"Ensure that events are well formed and that sequence conflicts surface properly when attempting to commit them to the log."},{"ref":"Maestro.Types.Event.html#t:aggregate_id/0","title":"Maestro.Types.Event.aggregate_id/0","type":"type","doc":""},{"ref":"Maestro.Types.Event.html#t:sequence/0","title":"Maestro.Types.Event.sequence/0","type":"type","doc":""},{"ref":"Maestro.Types.Event.html#t:t/0","title":"Maestro.Types.Event.t/0","type":"type","doc":""},{"ref":"Maestro.Types.Snapshot.html","title":"Maestro.Types.Snapshot","type":"module","doc":"Maestro.Aggregate.Roots can commit state that has been computed from events. Roots can commit state that has been computed from the application of events. This is useful if events are expensive to apply or if there are a sufficiently large number of events that replaying from sequence=1 would be impractical. With Maestro.Types.Events, :body is the necessary information to apply the event. In the case of Snapshots, the body is the actual computed state of the entity."},{"ref":"Maestro.Types.Snapshot.html#t:aggregate_id/0","title":"Maestro.Types.Snapshot.aggregate_id/0","type":"type","doc":""},{"ref":"Maestro.Types.Snapshot.html#t:sequence/0","title":"Maestro.Types.Snapshot.sequence/0","type":"type","doc":""},{"ref":"Maestro.Types.Snapshot.html#t:t/0","title":"Maestro.Types.Snapshot.t/0","type":"type","doc":""},{"ref":"Mix.Tasks.Maestro.Create.EventStoreMigration.html","title":"Mix.Tasks.Maestro.Create.EventStoreMigration","type":"task","doc":"Using the work already done in Mix.Ecto, generate a migration that creates the event_log and snapshot tables with HLC constraints. Example mix maestro.create.event_store_migration --repo MyApp.Repo mix maestro.create.event_store_migration -n diff_name_for_migration"},{"ref":"readme.html","title":"Maestro","type":"extras","doc":"Maestro Maestro is an event sourcing library. It is inspired by CQRS and re-uses terminology where appropriate. The divergence from being a CQRS framework is intentional as Maestro focuses on processing commands in a consistent manner and replaying events in a consistent order. Currently, the only storage adapter suited to a multi-node environment is the Maestro.Store.Postgres adapter. The Maestro.Store.InMemory adapter exists for testing purposes only."},{"ref":"readme.html#status","title":"Maestro - Status","type":"extras","doc":"Documentation is available here."},{"ref":"readme.html#installation","title":"Maestro - Installation","type":"extras","doc":"def deps do [{:maestro, &quot;~&gt; 0.2&quot;}] end"},{"ref":"readme.html#database-configuration","title":"Maestro - Database Configuration","type":"extras","doc":"Maestro is intended to be used alongside an existing database/ecto repo. config :maestro, storage_adapter: Maestro.Store.Postgres, repo: MyApp.Repo To generate the migrations for the snapshot and event logs, do: mix maestro.create.event_store_migration"},{"ref":"readme.html#example","title":"Maestro - Example","type":"extras","doc":"There are three behaviours that make the command/event lifecycle flow: Maestro.Aggregate.CommandHandler, Maestro.Aggregate.EventHandler, and Maestro.Aggregate.ProjectionHandler. Modules implementing the command and event handler behaviours are looked up via a configurable :command_prefix and :event_prefix respectively. Projections are reserved for maintaining other models/representations within the event&#39;s transaction. defmodule MyApp.Aggregate do use Maestro.Aggregate.Root, command_prefix: MyApp.Aggregate.Commands, event_prefix: MyApp.Aggregate.Events def initial_state, do: %{&quot;value&quot; =&gt; 0} def prepare_snapshot(state), do: state def use_snapshot(_curr, %Maestro.Types.Snapshot{body: state}), do: state end defmodule MyApp.Aggregate.Commands.IncrementCounter do @behaviour Maestro.Aggregate.CommandHandler alias Maestro.Types.Event def eval(aggregate, _command) do [ %Event{ aggregate_id: aggregate.id, type: &quot;counter_incremented&quot;, body: %{} } ] end end defmodule MyApp.Aggregate.Events.CounterIncremented do @behaviour Maestro.Aggregate.EventHandler def apply(state, _event), do: Map.update!(state, &quot;value&quot;, &amp;(&amp;1 + 1)) end iex(1)&gt; {:ok, id} = MyApp.Aggregate.new() iex(2)&gt; :ok = MyApp.Aggregate.evaluate(%Maestro.Types.Command{aggregate_id: id, type: &quot;increment_counter&quot;, data: %{}}) iex(3)&gt; {:ok, %{&quot;value&quot; =&gt; 1}} = MyApp.Aggregate.get(id)"}]